/* This file is auto-generated. Don't edit. */
#ifndef NASM_IFLAG_H__
#define NASM_IFLAG_H__

#include <inttypes.h>

#include <string.h>

#include "compiler.h"
extern int ilog2_32(uint32_t v);

/*
 * Instruction template flags. These specify which processor
 * targets the instruction is eligible for, whether it is
 * privileged or undocumented, and also specify extra error
 * checking on the matching of the instruction.
 *
 * IF_SM stands for Size Match: any operand whose size is not
 * explicitly specified by the template is `really' intended to be
 * the same size as the first size-specified operand.
 * Non-specification is tolerated in the input instruction, but
 * _wrong_ specification is not.
 *
 * IF_SM2 invokes Size Match on only the first _two_ operands, for
 * three-operand instructions such as SHLD: it implies that the
 * first two operands must match in size, but that the third is
 * required to be _unspecified_.
 *
 * IF_SB invokes Size Byte: operands with unspecified size in the
 * template are really bytes, and so no non-byte specification in
 * the input instruction will be tolerated. IF_SW similarly invokes
 * Size Word, and IF_SD invokes Size Doubleword.
 *
 * (The default state if neither IF_SM nor IF_SM2 is specified is
 * that any operand with unspecified size in the template is
 * required to have unspecified size in the instruction too...)
 *
 * iflag_t is defined to store these flags.
 */
#define IF_SM               (  0) /* Size match                                                       */
#define IF_SM2              (  1) /* Size match first two operands                                    */
#define IF_SB               (  2) /* Unsized operands can't be non-byte                               */
#define IF_SW               (  3) /* Unsized operands can't be non-word                               */
#define IF_SD               (  4) /* Unsized operands can't be non-dword                              */
#define IF_SQ               (  5) /* Unsized operands can't be non-qword                              */
#define IF_SO               (  6) /* Unsized operands can't be non-oword                              */
#define IF_SY               (  7) /* Unsized operands can't be non-yword                              */
#define IF_SZ               (  8) /* Unsized operands can't be non-zword                              */
#define IF_SIZE             (  9) /* Unsized operands must match the bitsize                          */
#define IF_SX               ( 10) /* Unsized operands not allowed                                     */
#define IF_AR0              ( 11) /* SB, SW, SD applies to argument 0                                 */
#define IF_AR1              ( 12) /* SB, SW, SD applies to argument 1                                 */
#define IF_AR2              ( 13) /* SB, SW, SD applies to argument 2                                 */
#define IF_AR3              ( 14) /* SB, SW, SD applies to argument 3                                 */
#define IF_AR4              ( 15) /* SB, SW, SD applies to argument 4                                 */
#define IF_OPT              ( 16) /* Optimizing assembly only                                         */
#define IF_PRIV             ( 32) /* Privileged instruction                                           */
#define IF_SMM              ( 33) /* Only valid in SMM                                                */
#define IF_PROT             ( 34) /* Protected mode only                                              */
#define IF_LOCK             ( 35) /* Lockable if operand 0 is memory                                  */
#define IF_NOLONG           ( 36) /* Not available in long mode                                       */
#define IF_LONG             ( 37) /* Long mode                                                        */
#define IF_NOHLE            ( 38) /* HLE prefixes forbidden                                           */
#define IF_MIB              ( 39) /* disassemble with split EA                                        */
#define IF_BND              ( 40) /* BND (0xF2) prefix available                                      */
#define IF_UNDOC            ( 41) /* Undocumented                                                     */
#define IF_HLE              ( 42) /* HLE prefixed                                                     */
#define IF_FPU              ( 43) /* FPU                                                              */
#define IF_MMX              ( 44) /* MMX                                                              */
#define IF_3DNOW            ( 45) /* 3DNow!                                                           */
#define IF_SSE              ( 46) /* SSE (KNI, MMX2)                                                  */
#define IF_SSE2             ( 47) /* SSE2                                                             */
#define IF_SSE3             ( 48) /* SSE3 (PNI)                                                       */
#define IF_VMX              ( 49) /* VMX                                                              */
#define IF_SSSE3            ( 50) /* SSSE3                                                            */
#define IF_SSE4A            ( 51) /* AMD SSE4a                                                        */
#define IF_SSE41            ( 52) /* SSE4.1                                                           */
#define IF_SSE42            ( 53) /* SSE4.2                                                           */
#define IF_SSE5             ( 54) /* SSE5                                                             */
#define IF_AVX              ( 55) /* AVX (128b)                                                       */
#define IF_AVX2             ( 56) /* AVX2 (256b)                                                      */
#define IF_FMA              ( 57) /*                                                                  */
#define IF_BMI1             ( 58) /*                                                                  */
#define IF_BMI2             ( 59) /*                                                                  */
#define IF_TBM              ( 60) /*                                                                  */
#define IF_RTM              ( 61) /*                                                                  */
#define IF_INVPCID          ( 62) /*                                                                  */
#define IF_AVX512           ( 64) /* AVX-512F (512b)                                                  */
#define IF_AVX512CD         ( 65) /* AVX-512 Conflict Detection                                       */
#define IF_AVX512ER         ( 66) /* AVX-512 Exponential and Reciprocal                               */
#define IF_AVX512PF         ( 67) /* AVX-512 Prefetch                                                 */
#define IF_MPX              ( 68) /* MPX                                                              */
#define IF_SHA              ( 69) /* SHA                                                              */
#define IF_PREFETCHWT1      ( 70) /* PREFETCHWT1                                                      */
#define IF_8086             ( 96) /* 8086                                                             */
#define IF_186              ( 97) /* 186+                                                             */
#define IF_286              ( 98) /* 286+                                                             */
#define IF_386              ( 99) /* 386+                                                             */
#define IF_486              (100) /* 486+                                                             */
#define IF_PENT             (101) /* Pentium                                                          */
#define IF_P6               (102) /* P6                                                               */
#define IF_KATMAI           (103) /* Katmai                                                           */
#define IF_WILLAMETTE       (104) /* Willamette                                                       */
#define IF_PRESCOTT         (105) /* Prescott                                                         */
#define IF_X86_64           (106) /* x86-64 (long or legacy mode)                                     */
#define IF_NEHALEM          (107) /* Nehalem                                                          */
#define IF_WESTMERE         (108) /* Westmere                                                         */
#define IF_SANDYBRIDGE      (109) /* Sandy Bridge                                                     */
#define IF_FUTURE           (110) /* Future processor (not yet disclosed)                             */
#define IF_IA64             (111) /* IA64 (in x86 mode)                                               */
#define IF_CYRIX            (112) /* Cyrix-specific                                                   */
#define IF_AMD              (113) /* AMD-specific                                                     */

typedef struct {
    uint32_t field[4];
} iflag_t;


extern iflag_t insns_flags[211];

#define IF_GENBIT(bit)          (UINT32_C(1) << (bit))

static inline unsigned int iflag_test(iflag_t *f,unsigned int bit)
{
    unsigned int index = bit / 32;
    return f->field[index] & (UINT32_C(1) << (bit - (index * 32)));
}

static inline void iflag_set(iflag_t *f, unsigned int bit)
{
    unsigned int index = bit / 32;
    f->field[index] |= (UINT32_C(1) << (bit - (index * 32)));
}

static inline void iflag_clear(iflag_t *f, unsigned int bit)
{
    unsigned int index = bit / 32;
    f->field[index] &= ~(UINT32_C(1) << (bit - (index * 32)));
}

static inline void iflag_clear_all(iflag_t *f)
{
     memset(f, 0, sizeof(*f));
}

static inline void iflag_set_all(iflag_t *f)
{
     memset(f, 0xff, sizeof(*f));
}

static inline int iflag_cmp(iflag_t *a, iflag_t *b)
{
    unsigned int i;

    for (i = 0; i < sizeof(a->field) / sizeof(a->field[0]); i++) {
        if (a->field[i] < b->field[i])
            return -1;
        else if (a->field[i] > b->field[i])
            return 1;
    }

    return 0;
}

static inline int iflag_cmp_cpu(iflag_t *a, iflag_t *b)
{
    if (a->field[3] < b->field[3])
        return -1;
    else if (a->field[3] > b->field[3])
        return 1;
    return 0;
}

static inline unsigned int iflag_ffs(iflag_t *a)
{
    unsigned int i;

    for (i = 0; i < sizeof(a->field) / sizeof(a->field[0]); i++) {
        if (a->field[i])
            return ilog2_32(a->field[i]) + (i * 32);
    }

    return 0;
}

#define IF_GEN_HELPER(name, op)                                         \
    static inline iflag_t iflag_##name(iflag_t *a, iflag_t *b)          \
    {                                                                   \
        unsigned int i;                                                 \
        iflag_t res;                                                    \
                                                                        \
        for (i = 0; i < sizeof(a->field) / sizeof(a->field[0]); i++)    \
            res.field[i] = a->field[i] op b->field[i];                  \
                                                                        \
        return res;                                                     \
    }

IF_GEN_HELPER(xor, ^)


/* Use this helper to test instruction template flags */
#define itemp_has(itemp, bit)   iflag_test(&insns_flags[(itemp)->iflag_idx], bit)


/* Maximum processor level at moment */
#define IF_PLEVEL               IF_IA64
/* Some helpers which are to work with predefined masks */
#define IF_SMASK        \
    (IF_GENBIT(IF_SB)  |\
     IF_GENBIT(IF_SW)  |\
     IF_GENBIT(IF_SD)  |\
     IF_GENBIT(IF_SQ)  |\
     IF_GENBIT(IF_SO)  |\
     IF_GENBIT(IF_SY)  |\
     IF_GENBIT(IF_SZ)  |\
     IF_GENBIT(IF_SIZE))
#define IF_ARMASK       \
    (IF_GENBIT(IF_AR0) |\
     IF_GENBIT(IF_AR1) |\
     IF_GENBIT(IF_AR2) |\
     IF_GENBIT(IF_AR3) |\
     IF_GENBIT(IF_AR4))

#define __itemp_smask(idx)      (insns_flags[(idx)].field[0] & IF_SMASK)
#define __itemp_armask(idx)     (insns_flags[(idx)].field[0] & IF_ARMASK)
#define __itemp_arg(idx)        ((__itemp_armask(idx) >> IF_AR0) - 1)

#define itemp_smask(itemp)      __itemp_smask((itemp)->iflag_idx)
#define itemp_arg(itemp)        __itemp_arg((itemp)->iflag_idx)
#define itemp_armask(itemp)     __itemp_armask((itemp)->iflag_idx)

static inline int iflag_cmp_cpu_level(iflag_t *a, iflag_t *b)
{
    iflag_t v1 = *a;
    iflag_t v2 = *b;

    iflag_clear(&v1, IF_CYRIX);
    iflag_clear(&v1, IF_AMD);

    iflag_clear(&v2, IF_CYRIX);
    iflag_clear(&v2, IF_AMD);

    if (v1.field[3] < v2.field[3])
        return -1;
    else if (v1.field[3] > v2.field[3])
        return 1;

    return 0;
}

static inline iflag_t __iflag_pfmask(iflag_t *a)
{
	iflag_t r = (iflag_t) {
		.field[1] = a->field[1],
		.field[2] = a->field[2],
	};

	if (iflag_test(a, IF_CYRIX))
		iflag_set(&r, IF_CYRIX);
	if (iflag_test(a, IF_AMD))
		iflag_set(&r, IF_AMD);

	return r;
}

#define iflag_pfmask(itemp)	__iflag_pfmask(&insns_flags[(itemp)->iflag_idx])

#endif /* NASM_IFLAG_H__ */
